-- Function to dig a cuboid with given dimensions
function excavate(depth, width, height)
    for h = 1, height do
        for w = 1, width do
            for d = 1, depth do
                turtle.dig() 
                turtle.forward() 
            end
            -- Return to starting position of each row
            if w < width then
                turtle.back(depth)
                if w % 2 == 0 then
                    turtle.turnRight()
                else
                    turtle.turnLeft()
                end
                turtle.forward()
                if w % 2 == 0 then
                    turtle.turnRight()
                else
                    turtle.turnLeft()
                end
            end
        end
        -- Go back to starting position of each layer and go up
        if h < height then
            if h % 2 == 0 then
                turtle.turnLeft()
            else
                turtle.turnRight()
            end
            turtle.back(width * depth)
            if h % 2 == 0 then
                turtle.turnLeft()
            else
                turtle.turnRight()
            end
            turtle.up()
        end
    end
    -- Return to the starting position
    turtle.back(height * width)
    turtle.turnRight()
    turtle.turnRight()
end

-- Retrieving parameters from input
local args = {...}
local depth = tonumber(args[1])
local width = tonumber(args[2])
local height = tonumber(args[3])

-- Validating input
if depth == nil or width == nil or height == nil then
    print("Usage: excavate <depth> <width> <height>")
else
    -- Excavating
    excavate(depth, width, height)
    print("Excavation completed!")
end
